
/* This section is done to put the models on the rows instead of the columns
			 It's dumb that it takes this much work to flip the rows/columns */
cap program drop rotate_reg_output
program define rotate_reg_output
	args demogs_flag
		esttab , se nostar keep($fs_out ) label
		matrix C = r(coefs)
		matrix S = r(stats)

		foreach var of varlist $outcomes{
			eststo drop `var'
		}

		local rnames : rownames C
		local models : coleq C
		local models : list uniq models
		local i 0
		foreach name of local rnames {
			local ++i
			local j 0
			capture matrix drop b
			capture matrix drop se

			foreach model of local models {
				local ++j
				matrix tmp = C[`i', 2*`j'-1]			
				if tmp[1,1]<. {
					matrix colnames tmp = `model'
					matrix b = nullmat(b), tmp
					matrix tmp[1,1] = C[`i', 2*`j']
					matrix se = nullmat(se), tmp
				}
			}
			
			
			ereturn post b
			qui estadd matrix se
			eststo
			estadd local t_fe "Yes"
			estadd local controls "`demogs_flag'"
		}
	
		cap mat drop f_ra_loc
		cap mat drop f_cd_loc
		if "`reg_type'" == "tsls"{
			local rows 0
			foreach var of varlist $outcomes {
				local ++rows
			}
			matrix f_ra_loc = J(`rows',1,.)
			matrix f_cd_loc = J(`rows',1,.)
			local k 1
			foreach var of varlist $outcomes {
				mat f_ra_loc[`k',1] = `f_ra_`var''
				mat f_cd_loc[`k',1] = `f_cd_`var''
				
				local label : variable label `var'
				local lab_list "`lab_list' `label'"
				
				local ++k
			}
		}
		else if "`reg_type'" == "tsls_prior_off" {
			local rows 0
			foreach var of varlist $outcomes {
				local ++rows
			}
			matrix f_ra_loc = J(`rows',1,.)
			matrix f_cd_loc = J(`rows',1,.)
			local k 1
			foreach var of varlist $outcomes {
				mat f_ra_loc[`k',1] = `f_ra_`var''
				mat f_cd_loc[`k',1] = `f_cd_`var''
				
				local ++k
			}
		}
end
